/* test.c - a simple test harness. */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#ifdef MACOS
#ifdef THINK_C
#include <console.h>
#include <unix.h>
#include <fcntl.h>
#endif /* THINK_C */
#include "macos.h"
#else /* MACOS */
#if defined( DOS )
#include "msdos.h"
#if defined( WINSOCK ) 
#include "console.h"
#endif /* WINSOCK */
#else /* DOS */
#ifdef _WINDOWS
#include <windows.h>
#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
//#include "console.h"
#else /* _WINDOWS */
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/file.h>
#ifndef VMS
#include <fcntl.h>
#include <unistd.h>
#endif /* VMS */
#endif /* _WINDOWS */
#endif /* DOS */
#endif /* MACOS */

#undef NET_SSL

#if defined(NET_SSL)
#include <sec.h>
static SECCertDBHandle        certdbhandle;
#endif

#include "ldap.h"
#include "disptmpl.h"
//#include "ldaplog.h"
#ifndef NO_LIBLCACHE
//#include "lcache.h"
#endif /* !NO_LIBLCACHE */

#if !defined( PCNFS ) && !defined( WINSOCK ) && !defined( MACOS )
#define MOD_USE_BVALS
#endif /* !PCNFS && !WINSOCK && !MACOS */
////////////////
#include "gssldap.h"
#include "gsssasl.h"
char *argv0;
char *c;
char *attributeNames[20];
char *attributeValues[20];
int numAttrs = 0;
char	*optarg;
int	optind;
int verbose = 3;
int ldap_debug=1;
/////////////////////////////////
int convert_domain_to_dn(char *domain, char **bind_path);
void usage();
int printdse( LDAP *ld ) ;
int check_version( char *hostname, int portnum );

#define MODIFY_DN "CN=javatest,CN=Users,DC=QDMS,DC=CO,DC=IN"
LDAPMod *list_of_mods[1];
LDAPMod attribute1;
int msgid;
   char         *vals0[ 1 ];

int main(int argc, char *argv[])
{
	LDAP *ld;
	int i, rc;
	LDAPMessage *res;
	char *bind_path = NULL;
	char *add_path = NULL;
	u_short ldap_port = LDAP_PORT;
	char *ldap_host = NULL;
	int ch;
	char *user, *cp;
	char *admindn = NULL;
	char *domain = NULL;
	char *defOU = NULL, *ou = NULL; //CN=Users,
	int num_ds_hosts;
	
	int deluser = 0;
	int accountFound = 0;
	int invalidateAccount = 0;

	char *c;
	char *attributeNames[20];
	char *attributeValues[20];
	int numAttrs = 0;

	if (argv0 = strrchr(argv[0], '/'))
	    argv0++;
	else
	    argv0 = argv[0];

	verbose++;

     if (argc < 3)
	  usage();
 /* Parse arguments. */
	//[-vxI] [-A admin-account-dn] [-D domain] [-O ous] [-s LDAPserver] [-p LDAPport] [-B bind-path] [-a attributeName=value] <user@domain>
	//[-v] [-A admin-account-dn] [-D domain] [-O ous] [-s LDAPserver] [-p LDAPport] [-B bind-path] [-a attributeName=value] <user@domain>
     argc--; argv++;
     while (argc) {
	  if (strcmp(*argv, "-v") == 0) {
	       argc--; argv++;
	       verbose++;
	   } else if (strcmp(*argv, "-A") == 0) {
	       argc--; argv++;
		    admindn = *argv;
	   } else if (strcmp(*argv, "-p") == 0) {
	       argc--; argv++;
		   if (!argc) usage();
		   ldap_port = atoi(*argv);
	   }else if (strcmp(*argv, "-D") == 0) {
	       argc--; argv++;
		   if (!argc) usage();
		   domain = *argv;
	   } else if (strcmp(*argv, "-s") == 0) {
	       argc--; argv++;
	       if (!argc) usage();
		   ldap_host = *argv;
	   }else if (strcmp(*argv, "-B") == 0) {
	       argc--; argv++;
	       if (!argc) usage();
		   bind_path = *argv;
	   } else if (strcmp(*argv, "-O") == 0) {
	       argc--; argv++;	       
		   ou = *argv;
	   }else if (strcmp(*argv, "-D") == 0) {
	       argc--; argv++;
	       if (!argc) usage();
		   domain = *argv;
	   } else if (strcmp(*argv, "-a") == 0) {
	       argc--; argv++;
				if (!(c = strrchr(*argv, '=')))
					usage();
				else {
					*c = '\0';
					attributeNames[numAttrs] = *argv;
					attributeValues[numAttrs++] = c + 1;
				}
	   }else {		    
			user=*argv;		
	   }
	   argc--; argv++;
	 }	

	//attributeNames[numAttrs] = NULL;
	//attributeValues[numAttrs] = NULL;

	if (!domain) {
	    domain = strchr(user, '@');
	    if (domain)
		domain++;
	    else
		usage();
	}

	if (verbose > 2)
	    ldap_debug = 1 /*LDAP_DEBUG_TRACE*/;

	if (cp = strchr(user, '@'))
	    *cp = '\0';

	if (!bind_path) {
	    convert_domain_to_dn(domain, &bind_path);
	    if (!ou)
	      ou = defOU;
	}

	if (verbose) {
	    if (!deluser)
	      printf("Creating user account for %s\n", user);
	    else
	      printf("Deleting user account for %s\n", user);
	}
	/*
	if (ldap_host) {
	    static SRV_LOCATION srv_ldap;
	    static PSRV_LOCATION psrv_ldap[1];

	    psrv_ldap[0] = &srv_ldap;
	    srv_ldap.srv_host = ldap_host;
	    srv_ldap.srv_port = ldap_port;
	    ds_hosts = psrv_ldap;
	    num_ds_hosts = 1;		
	}
	*/

	//for (i = 0; i < num_ds_hosts; i++) {
	    ld = ldap_open(ldap_host, 389);
//	    if (ld)
//			break;
	//}
	if (ld == NULL) {
	    perror("ldap_open");
	    return 1;
	}	

	rc = LDAP_VERSION3;
	(void)ldap_set_option(ld, LDAP_OPT_PROTOCOL_VERSION, &rc);
	fprintf(stdout, "printdse=%d\n",printdse(ld));
	
//#ifdef HAVE_LIBGSSLDAP

	    rc = ldap_gssapi_bind(ld, bind_path, GSSSASL_NO_SECURITY_LAYER);
		fprintf(stdout, "after ldap_gssapi_bind \n");
	    if (rc != LDAP_SUCCESS) {
			fprintf(stdout, "an error occurred in ldap_gssapi_bind\n");
			ldap_perror(ld, "ldap_gssapi_bind");
			ldap_unbind(ld);
			return 1;
	    }

	fprintf(stdout,"check_version=%d",check_version(ldap_host,389));
	fprintf(stdout, "printdse=%d\n",printdse(ld));
fprintf(stdout, "before LDAP_MOD_REPLACE\n\n\n");
 attribute1.mod_op = LDAP_MOD_REPLACE;
    attribute1.mod_type = "givenName";
    vals0[0] = "wbj";
    vals0[1] = NULL;
    attribute1.mod_values = vals0;
	list_of_mods[0] = &attribute1;
	list_of_mods[1] = NULL;

	// Send the LDAP modify request.
    rc = ldap_modify_ext( ld, MODIFY_DN, list_of_mods, NULL, NULL, &msgid );
   if ( rc != LDAP_SUCCESS ) {
	   ldap_perror(ld, "ldap_modify_s");
      fprintf( stderr, "ldap_modify_ext: %s\n", ldap_err2string( rc ) );
      ldap_unbind( ld );
      return( 1 );
    }
    
    rc=ldap_unbind(ld);
	if ( rc != LDAP_SUCCESS ) {
		fprintf( stderr, "ldap_modify_ext: %s\n", ldap_err2string( rc ) );
	}
    fprintf(stdout, "after LDAP_MOD_REPLACE\n");
   exit(0);
}
  
int convert_domain_to_dn(
    char *domain,
    char **dnp
    )
{
    char *fp, *dp;
    char dn[1024];
    int dnlen = 1;

    memset(dn, 0, sizeof(dn));
    strcpy(dn, "dc=");
    dp = dn+3;
    for (fp = domain; *fp; fp++) {
	if (*fp == '.') {
	    strcpy(dp, ",dc=");
	    dp += 4;
	}
	else
	    *dp++ = *fp;
    }

    *dnp = strdup(dn);
    return 0;
}

void usage()
{
    printf("%s: [-vxI] [-A admin-account-dn] [-D domain] [-O ous] [-s LDAPserver] [-p LDAPport] [-B bind-path] [-a attributeName=value] <user@domain>\n", argv0);
    exit(1);
}

int check_version( char *hostname, int portnum )
{
   LDAP      *ld;
   int      i, rc, v3supported = 0;
   LDAPMessage   *result, *e;
   BerElement   *ber;
   LDAPControl   **serverctrls = NULL, **clntctrls = NULL;
   char      *a, *dn;
   char      **vals;
   char      *attrs[2];
   char      *filter = "(objectClass=*)";
   /* Check arguments */
   if ( !hostname || !hostname[0] || !portnum ) {
      printf( "Error: hostname or port number not specified\n" );
      return( -1 );
   }
   /* Get a handle to an LDAP connection. */
      if ( (ld = ldap_init( hostname, portnum )) == NULL ) {
      perror( "ldap_init" );
      return( -1 );
   }
   //if ( (ld = ldap_init( hostname, portnum )) == NULL ) {
   //   perror( "ldap_init" );
   //   return( -1 );
   //}
   /* Set automatic referral processing off. */
   if ( ldap_set_option( ld, LDAP_OPT_REFERRALS, LDAP_OPT_OFF ) != LDAP_SUCCESS ) {
      ldap_perror( ld, "ldap_set_option" );
      return( -1 );
   }
   /* Search for the root DSE and get the supportedLDAPVersion attribute. */
   attrs[0] = "supportedLDAPVersion";
   attrs[1] = NULL;
   rc = ldap_search_ext_s( ld, "", LDAP_SCOPE_BASE, filter, attrs, 0,
      serverctrls, clntctrls, NULL, 0, &result );
   /* Check the search results. */
   switch( rc ) {
   /* If successful, the root DSE was found. */
   case LDAP_SUCCESS:
      break;
   /* If the root DSE was not found, the server does not comply
      with the LDAP v3 protocol. */
   case LDAP_PARTIAL_RESULTS:
   case LDAP_NO_SUCH_OBJECT:
   case LDAP_OPERATIONS_ERROR:
   case LDAP_PROTOCOL_ERROR:
      ldap_perror( ld, "ldap_search_ext_s" );
      return( 0 );
      break;
   /* If an different result code is returned, an error may have
      occurred (for example, the server may be down. */
   default:
      ldap_perror( ld, "ldap_search_ext_s" );
      return( -1 );
      break;
   }
   /* Get the values of the supportedLDAPVersion attribute in the entry. */
   if (( e = ldap_first_entry( ld, result )) != NULL  &&
       ( a = ldap_first_attribute( ld, e, &ber )) != NULL  &&
       (vals = ldap_get_values( ld, e, a)) != NULL ) {
      for ( i = 0; vals[i] != NULL; i++ ) {
         if ( !strcmp( "3", vals[i] ) ) {
            v3supported = 1;
            break;
         }
      }
      /* Free any memory allocated. */
      ldap_value_free( vals );
      ldap_memfree( a );
      if ( ber != NULL ) {
         ber_free( ber, 0 );
      }
   }
   /* Free memory allocated by ldap_search_ext_s(). */
   ldap_msgfree( result );
   /* Free the ld structure. */
   //ldap_unbind_s( ld );
   /* Return a value indicating whether or not LDAP v3 is supported. */
   return( v3supported );
}

int printdse( LDAP *ld )
{
   int rc, i;
   char *matched_msg = NULL, *error_msg = NULL;
   LDAPMessage   *result, *e;
   BerElement   *ber;
   char      *a;
   char      **vals;
   /* Verify that the connection handle is valid. */
   if ( ld == NULL ) {
      fprintf( stderr, "Invalid connection handle.\n" );
      return( 1 );
   }
   /* Set automatic referral processing off. */
   if ( ldap_set_option( ld, LDAP_OPT_REFERRALS, LDAP_OPT_OFF ) != 0 ) {
      rc = ldap_get_lderrno( ld, NULL, NULL );
      fprintf( stderr, "ldap_set_option: %s\n", ldap_err2string( rc ) );
      return( 1 );
   }
   /* Search for the root DSE. */
   rc = ldap_search_ext_s( ld, "", LDAP_SCOPE_BASE, "(objectclass=*)", NULL, 0,
      NULL, NULL, NULL, 0, &result );
   /* Check the search results. */
   switch( rc ) {
   /* If successful, the root DSE was found. */
   case LDAP_SUCCESS:
      break;
   /* If the root DSE was not found, the server does not comply
      with the LDAP v3 protocol. */
   case LDAP_PARTIAL_RESULTS:
   case LDAP_NO_SUCH_OBJECT:
   case LDAP_OPERATIONS_ERROR:
   case LDAP_PROTOCOL_ERROR:
      printf( "LDAP server returned result code %d (%s).\n"
         "This server does not support the LDAP v3 protocol.\n",
         rc, ldap_err2string( rc ) );
      return( 1 );
   /* If any other value is returned, an error must have occurred. */
   default:
      fprintf( stderr, "printdse: %s\n", ldap_err2string( rc ) );
      return( 1 );
   }
   /* Since only one entry should have matched, get that entry. */
   e = ldap_first_entry( ld, result );
   if ( e == NULL ) {
      fprintf( stderr, "printdse: Unable to get root DSE.\n");
      ldap_memfree( result );
      return( 1 );
   }

   /* Iterate through each attribute in the entry. */
   for ( a = ldap_first_attribute( ld, e, &ber );
      a != NULL; a = ldap_next_attribute( ld, e, ber ) ) {

      /* Print each value of the attribute. */
      if ((vals = ldap_get_values( ld, e, a)) != NULL ) {
         for ( i = 0; vals[i] != NULL; i++ ) {
            printf( "%s: %s\n", a, vals[i] );
         }

         /* Free memory allocated by ldap_get_values(). */
         ldap_value_free( vals );
      }

      /* Free memory allocated by ldap_first_attribute(). */
      ldap_memfree( a );
   }

   /* Free memory allocated by ldap_first_attribute(). */
   if ( ber != NULL ) {
      ber_free( ber, 0 );
   }

   printf( "\n" );
   /* Free memory allocated by ldap_search_ext_s(). */
   ldap_msgfree( result );
//   ldap_unbind( ld );
   return( 0 );
}
